/*******************************************************************************
* File Name: Count16_MMSBCount7.h
* Version 1.0
*
* Description:
*  This header file contains registers and constants associated with the
*  Count7 component.
*
* Note:
*
********************************************************************************
* Copyright 2013, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_COUNT7_Count16_MMSBCount7_H)
#define CY_COUNT7_Count16_MMSBCount7_H

#include "cyfitter.h"

#if ((CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC3) || \
     (CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC4) || \
     (CYDEV_CHIP_FAMILY_USED == CYDEV_CHIP_FAMILY_PSOC5))
    #include "cytypes.h"
    #include "CyLib.h"
#else
    #include "syslib/cy_syslib.h"
#endif


/***************************************
* Function Prototypes
***************************************/
void  Count16_MMSBCount7_Init(void) ;
void  Count16_MMSBCount7_Enable(void) ;
void  Count16_MMSBCount7_Start(void) ;
void  Count16_MMSBCount7_Stop(void) ;
void  Count16_MMSBCount7_WriteCounter(uint8 count) ;
uint8 Count16_MMSBCount7_ReadCounter(void) ;
void  Count16_MMSBCount7_WritePeriod(uint8 period) ;
uint8 Count16_MMSBCount7_ReadPeriod(void) ;
void  Count16_MMSBCount7_SaveConfig(void) ;
void  Count16_MMSBCount7_RestoreConfig(void) ;
void  Count16_MMSBCount7_Sleep(void) ;
void  Count16_MMSBCount7_Wakeup(void) ;


/***************************************
*     Data Struct Definitions
***************************************/
/* Structure to save registers before go to sleep */
typedef struct
{
    uint8 enableState;
    uint8 count;
} Count16_MMSBCount7_BACKUP_STRUCT;


/***************************************
*           Global Variables
***************************************/
extern Count16_MMSBCount7_BACKUP_STRUCT Count16_MMSBCount7_backup;
extern uint8 Count16_MMSBCount7_initVar;


/***************************************
* Initial Parameter
***************************************/
#define Count16_MMSBCount7_INITIAL_PERIOD               (3u)


/***************************************
* Registers
***************************************/
#define Count16_MMSBCount7_COUNT_REG                    (*(reg8 *) Count16_MMSBCount7_Counter7__COUNT_REG)
#define Count16_MMSBCount7_COUNT_PTR                    ( (reg8 *) Count16_MMSBCount7_Counter7__COUNT_REG)
#define Count16_MMSBCount7_PERIOD_REG                   (*(reg8 *) Count16_MMSBCount7_Counter7__PERIOD_REG)
#define Count16_MMSBCount7_PERIOD_PTR                   ( (reg8 *) Count16_MMSBCount7_Counter7__PERIOD_REG)
#define Count16_MMSBCount7_AUX_CONTROL_REG              (*(reg8 *) Count16_MMSBCount7_Counter7__CONTROL_AUX_CTL_REG)
#define Count16_MMSBCount7_AUX_CONTROL_PTR              ( (reg8 *) Count16_MMSBCount7_Counter7__CONTROL_AUX_CTL_REG)


/***************************************
* Register Constants
***************************************/
#define Count16_MMSBCount7_COUNTER_START                (0x20u)

/* This constant is used to mask the TC bit (bit#7) in the Count register */
#define Count16_MMSBCount7_COUNT_7BIT_MASK              (0x7Fu)


#endif /* CY_COUNT7_Count16_MMSBCount7_H */


/* [] END OF FILE */
