/***************************************************************************//**
* \file DMA_Tmp2CircBuf.c
* \version 2.0
*
*  This file provides the source code to the API for the
*  DMA_Tmp2CircBuf component.
*
********************************************************************************
* \copyright
* Copyright 2016-2017, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "DMA_Tmp2CircBuf.h"

#if defined(__cplusplus)
extern "C" {
#endif

/* Generated code */
const cy_stc_dma_descriptor_config_t DMA_Tmp2CircBuf_Descriptor_1_config =
{
    .retrigger       = CY_DMA_RETRIG_IM,
    .interruptType   = CY_DMA_DESCR,
    .triggerOutType  = CY_DMA_DESCR,
    .channelState    = CY_DMA_CHANNEL_ENABLED,
    .triggerInType   = CY_DMA_1ELEMENT,
    .dataSize        = CY_DMA_WORD,
    .srcTransferSize = CY_DMA_TRANSFER_SIZE_DATA,
    .dstTransferSize = CY_DMA_TRANSFER_SIZE_DATA,
    .descriptorType  = CY_DMA_2D_TRANSFER,
    .srcAddress      = NULL,
    .dstAddress      = NULL,
    .srcXincrement   = 0L,
    .dstXincrement   = 1L,
    .xCount          = 5UL,
    .srcYincrement   = 0L,
    .dstYincrement   = 5L,
    .yCount          = 4UL,
    .nextDescriptor  = &DMA_Tmp2CircBuf_Descriptor_2
};

cy_stc_dma_descriptor_t DMA_Tmp2CircBuf_Descriptor_1 =
{
    .ctl = 0UL,
    .src = 0UL,
    .dst = 0UL,
    .xCtl = 0UL,
    .yCtl = 0UL,
    .nextPtr = 0UL
};

const cy_stc_dma_descriptor_config_t DMA_Tmp2CircBuf_Descriptor_2_config =
{
    .retrigger       = CY_DMA_RETRIG_IM,
    .interruptType   = CY_DMA_DESCR_CHAIN,
    .triggerOutType  = CY_DMA_DESCR_CHAIN,
    .channelState    = CY_DMA_CHANNEL_ENABLED,
    .triggerInType   = CY_DMA_1ELEMENT,
    .dataSize        = CY_DMA_WORD,
    .srcTransferSize = CY_DMA_TRANSFER_SIZE_DATA,
    .dstTransferSize = CY_DMA_TRANSFER_SIZE_DATA,
    .descriptorType  = CY_DMA_2D_TRANSFER,
    .srcAddress      = NULL,
    .dstAddress      = NULL,
    .srcXincrement   = 0L,
    .dstXincrement   = 1L,
    .xCount          = 5UL,
    .srcYincrement   = 0L,
    .dstYincrement   = 5L,
    .yCount          = 4UL,
    .nextDescriptor  = &DMA_Tmp2CircBuf_Descriptor_3
};

cy_stc_dma_descriptor_t DMA_Tmp2CircBuf_Descriptor_2 =
{
    .ctl = 0UL,
    .src = 0UL,
    .dst = 0UL,
    .xCtl = 0UL,
    .yCtl = 0UL,
    .nextPtr = 0UL
};

const cy_stc_dma_descriptor_config_t DMA_Tmp2CircBuf_Descriptor_3_config =
{
    .retrigger       = CY_DMA_RETRIG_IM,
    .interruptType   = CY_DMA_DESCR_CHAIN,
    .triggerOutType  = CY_DMA_DESCR_CHAIN,
    .channelState    = CY_DMA_CHANNEL_ENABLED,
    .triggerInType   = CY_DMA_1ELEMENT,
    .dataSize        = CY_DMA_WORD,
    .srcTransferSize = CY_DMA_TRANSFER_SIZE_DATA,
    .dstTransferSize = CY_DMA_TRANSFER_SIZE_DATA,
    .descriptorType  = CY_DMA_2D_TRANSFER,
    .srcAddress      = NULL,
    .dstAddress      = NULL,
    .srcXincrement   = 0L,
    .dstXincrement   = 1L,
    .xCount          = 5UL,
    .srcYincrement   = 0L,
    .dstYincrement   = 5L,
    .yCount          = 4UL,
    .nextDescriptor  = &DMA_Tmp2CircBuf_Descriptor_1
};

cy_stc_dma_descriptor_t DMA_Tmp2CircBuf_Descriptor_3 =
{
    .ctl = 0UL,
    .src = 0UL,
    .dst = 0UL,
    .xCtl = 0UL,
    .yCtl = 0UL,
    .nextPtr = 0UL
};


/** DMA_Tmp2CircBuf_initVar indicates whether the DMA_Tmp2CircBuf 
*  component has been initialized. The variable is initialized to 0 
*  and set to 1 the first time DMA_Tmp2CircBuf_Start() is called. This allows 
*  the component to restart without reinitialization after the first 
*  call to the DMA_Tmp2CircBuf_Start() routine.
*
*  If re-initialization of the component is required, then the 
*  DMA_Tmp2CircBuf_Init() function can be called before the 
*  DMA_Tmp2CircBuf_Start() or DMA_Tmp2CircBuf_ChEnable() function.
*/
uint8 DMA_Tmp2CircBuf_initVar = 0u;


/*******************************************************************************
* Function Name: DMA_Tmp2CircBuf_Start
****************************************************************************//**
*
* Based on the settings for descriptor in the customizer this function runs the
* DMA_Descriptor_Init() and then initializes the channel using
* DMA_Chnl_Init(). Enables the DMA_Tmp2CircBuf block using the DMA_Chnl_Enable().
*  
*******************************************************************************/
void DMA_Tmp2CircBuf_Start(void const * srcAddress, void const * dstAddress)
{
    if (0U == DMA_Tmp2CircBuf_initVar)
    {
        DMA_Tmp2CircBuf_Init();
        DMA_Tmp2CircBuf_initVar = 1u;
    }
    
    Cy_DMA_Descriptor_SetSrcAddress(&DMA_Tmp2CircBuf_Descriptor_1, srcAddress);
    Cy_DMA_Descriptor_SetDstAddress(&DMA_Tmp2CircBuf_Descriptor_1, dstAddress);
    Cy_DMA_Channel_Enable(DMA_Tmp2CircBuf_HW, DMA_Tmp2CircBuf_DW_CHANNEL);
}


/*******************************************************************************
* Function Name: DMA_Tmp2CircBuf_Init
****************************************************************************//**
*
* Based on the settings for the descriptor in the customizer this function runs the
* DMA_Descriptor_Init() and then initializes the channel using
* DMA_Chnl_Init().
*  
*******************************************************************************/
void DMA_Tmp2CircBuf_Init(void)
{
    cy_stc_dma_channel_config_t channelConfig;

    /* Init all descriptors */
    (void)Cy_DMA_Descriptor_Init(&DMA_Tmp2CircBuf_Descriptor_1, &DMA_Tmp2CircBuf_Descriptor_1_config);
    (void)Cy_DMA_Descriptor_Init(&DMA_Tmp2CircBuf_Descriptor_2, &DMA_Tmp2CircBuf_Descriptor_2_config);
    (void)Cy_DMA_Descriptor_Init(&DMA_Tmp2CircBuf_Descriptor_3, &DMA_Tmp2CircBuf_Descriptor_3_config);


    channelConfig.descriptor  = &DMA_Tmp2CircBuf_Descriptor_1;
    channelConfig.preemptable = DMA_Tmp2CircBuf_PREEMPTABLE;
    channelConfig.priority    = DMA_Tmp2CircBuf_PRIORITY;
    channelConfig.enable      = false;
    channelConfig.bufferable  = DMA_Tmp2CircBuf_BUFFERABLE;

    (void)Cy_DMA_Channel_Init(DMA_Tmp2CircBuf_HW, DMA_Tmp2CircBuf_DW_CHANNEL, &channelConfig);

    Cy_DMA_Enable(DMA_Tmp2CircBuf_HW);
}


#if defined(__cplusplus)
}
#endif

/* [] END OF FILE */
