/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

unsigned int circularBuff[3*20] = {0};
unsigned char tmp[4] = {0};

void routine_Reg2Tmp(void)
{
    NVIC_ClearPendingIRQ(isr_Reg2Tmp_cfg.intrSrc);
    Cy_DMA_Channel_ClearInterrupt(DMA_Reg2Tmp_DW__BLOCK_HW, DMA_Reg2Tmp_DW__CHANNEL_NUMBER);   
}

unsigned char circCount = 0;
void routine_Tmp2CircBuf(void)
{
    NVIC_ClearPendingIRQ(isr_Tmp2CircBuf_cfg.intrSrc);
    Cy_DMA_Channel_ClearInterrupt(DMA_Tmp2CircBuf_DW__BLOCK_HW, DMA_Tmp2CircBuf_DW__CHANNEL_NUMBER);
    circCount++;
    for(int i = 0; i<circCount;i++)
    {
        Cy_GPIO_Write(isr_Reg2TmpOut_0_PORT, isr_Reg2TmpOut_0_NUM, 1);
        Cy_GPIO_Write(isr_Reg2TmpOut_0_PORT, isr_Reg2TmpOut_0_NUM, 0);
    }
    if(circCount == 3) circCount = 0;
}

int main(void)
{
    cy_stc_dma_channel_config_t channelConfig;
    int current, previous =0;
    
    Cy_SysInt_Init(&isr_Reg2Tmp_cfg, routine_Reg2Tmp);
    NVIC_ClearPendingIRQ(isr_Reg2Tmp_cfg.intrSrc);
    NVIC_EnableIRQ(isr_Reg2Tmp_cfg.intrSrc);
    Cy_SysInt_Init(&isr_Tmp2CircBuf_cfg, routine_Tmp2CircBuf);
    NVIC_ClearPendingIRQ(isr_Tmp2CircBuf_cfg.intrSrc);
    NVIC_EnableIRQ(isr_Tmp2CircBuf_cfg.intrSrc);
      
    __enable_irq(); /* Enable global interrupts. */    
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    CapSense_Start();
    CapSense_ScanAllWidgets();
    
    Count7_Start();
    Count16_Start();
    
    Cy_DMA_Descriptor_Init(&DMA_Reg2Tmp_Descriptor_1, &DMA_Reg2Tmp_Descriptor_1_config);
    Cy_DMA_Descriptor_SetSrcAddress(&DMA_Reg2Tmp_Descriptor_1, (const void *) StatusReg0_Status_PTR);
    Cy_DMA_Descriptor_SetDstAddress(&DMA_Reg2Tmp_Descriptor_1, tmp);    
    
    Cy_DMA_Descriptor_Init(&DMA_Reg2Tmp_Descriptor_2, &DMA_Reg2Tmp_Descriptor_2_config);
    Cy_DMA_Descriptor_SetSrcAddress(&DMA_Reg2Tmp_Descriptor_2, (const void *) StatusReg1_Status_PTR);
    Cy_DMA_Descriptor_SetDstAddress(&DMA_Reg2Tmp_Descriptor_2, tmp+1);
    
    Cy_DMA_Descriptor_Init(&DMA_Reg2Tmp_Descriptor_3, &DMA_Reg2Tmp_Descriptor_3_config);
    Cy_DMA_Descriptor_SetSrcAddress(&DMA_Reg2Tmp_Descriptor_3, (const void *) StatusReg2_Status_PTR);
    Cy_DMA_Descriptor_SetDstAddress(&DMA_Reg2Tmp_Descriptor_3, tmp+2);
    
    Cy_DMA_Descriptor_Init(&DMA_Reg2Tmp_Descriptor_4, &DMA_Reg2Tmp_Descriptor_4_config);
    Cy_DMA_Descriptor_SetSrcAddress(&DMA_Reg2Tmp_Descriptor_4, (const void *) StatusReg3_Status_PTR);
    Cy_DMA_Descriptor_SetDstAddress(&DMA_Reg2Tmp_Descriptor_4, tmp+3);
    
    channelConfig.descriptor    = &DMA_Reg2Tmp_Descriptor_1;
    channelConfig.preemptable   = DMA_Reg2Tmp_PREEMPTABLE;
    channelConfig.priority      = DMA_Reg2Tmp_PRIORITY;
    channelConfig.enable        = 0u;

    Cy_DMA_Channel_Init(DMA_Reg2Tmp_DW__BLOCK_HW, DMA_Reg2Tmp_DW_CHANNEL, &channelConfig);
    Cy_DMA_Channel_Enable(DMA_Reg2Tmp_DW__BLOCK_HW, DMA_Reg2Tmp_DW__CHANNEL_NUMBER);
    Cy_DMA_Channel_SetInterruptMask(DMA_Reg2Tmp_DW__BLOCK_HW, DMA_Reg2Tmp_DW__CHANNEL_NUMBER, CY_DMA_INTR_MASK);
    Cy_DMA_Enable(DMA_Reg2Tmp_DW__BLOCK_HW);
    
    Cy_DMA_Descriptor_Init(&DMA_Tmp2CircBuf_Descriptor_1, &DMA_Tmp2CircBuf_Descriptor_1_config);
    Cy_DMA_Descriptor_SetSrcAddress(&DMA_Tmp2CircBuf_Descriptor_1, tmp);
    Cy_DMA_Descriptor_SetDstAddress(&DMA_Tmp2CircBuf_Descriptor_1, circularBuff);    
    
    Cy_DMA_Descriptor_Init(&DMA_Tmp2CircBuf_Descriptor_2, &DMA_Tmp2CircBuf_Descriptor_2_config);
    Cy_DMA_Descriptor_SetSrcAddress(&DMA_Tmp2CircBuf_Descriptor_2, tmp);
    Cy_DMA_Descriptor_SetDstAddress(&DMA_Tmp2CircBuf_Descriptor_2, circularBuff+20);
    
    Cy_DMA_Descriptor_Init(&DMA_Tmp2CircBuf_Descriptor_3, &DMA_Tmp2CircBuf_Descriptor_3_config);
    Cy_DMA_Descriptor_SetSrcAddress(&DMA_Tmp2CircBuf_Descriptor_3, tmp);
    Cy_DMA_Descriptor_SetDstAddress(&DMA_Tmp2CircBuf_Descriptor_3, circularBuff+40);
    
    channelConfig.descriptor    = &DMA_Tmp2CircBuf_Descriptor_1;
    channelConfig.preemptable   = DMA_Tmp2CircBuf_PREEMPTABLE;
    channelConfig.priority      = DMA_Tmp2CircBuf_PRIORITY;
    channelConfig.enable        = 0u;

    Cy_DMA_Channel_Init(DMA_Tmp2CircBuf_DW__BLOCK_HW, DMA_Tmp2CircBuf_DW_CHANNEL, &channelConfig);
    Cy_DMA_Channel_Enable(DMA_Tmp2CircBuf_DW__BLOCK_HW, DMA_Tmp2CircBuf_DW__CHANNEL_NUMBER);
    Cy_DMA_Channel_SetInterruptMask(DMA_Tmp2CircBuf_DW__BLOCK_HW, DMA_Tmp2CircBuf_DW__CHANNEL_NUMBER, CY_DMA_INTR_MASK);
    Cy_DMA_Enable(DMA_Tmp2CircBuf_DW__BLOCK_HW);
    
    for(;;)
    {
        /* Place your application code here. */
        
        Cy_GPIO_Inv(LED9_0_PORT, LED9_0_NUM);
        Cy_SysLib_Delay(125u);
        
        if(!CapSense_IsBusy()){
            CapSense_ProcessAllWidgets();
            current = CapSense_IsAnyWidgetActive();
            if(previous==0 && current){
                Cy_GPIO_Inv(LED8_0_PORT, LED8_0_NUM); /* toggle the pin */
            }
            previous = current;
            CapSense_UpdateAllBaselines();
            CapSense_ScanAllWidgets();
        }
    }

}

/* [] END OF FILE */
